#Import-Module WinForms
[void] [System.Reflection.Assembly]::LoadWithPartialName("System.Drawing")
[void] [System.Reflection.Assembly]::LoadWithPartialName("System.Windows.Forms")
Add-Type -AssemblyName System.Windows.Forms
$Form = New-Object System.Windows.Forms.Form
$Form.Size = New-Object System.Drawing.Size(600, 400)

############################################## Start functions

function pingInfo {
    $wks = $InputBox.text;
    $pingResult = PING.EXE $wks | Format-List | Out-String;
    $outputBox.text = $pingResult
} #end pingInfo

############################################## end functions

############################################## Start text fields

$InputBox = New-Object System.Windows.Forms.TextBox
$InputBox.Location = New-Object System.Drawing.Size(20, 50)
$InputBox.Size = New-Object System.Drawing.Size(150, 20)
$Form.Controls.Add($InputBox)

$outputBox = New-Object System.Windows.Forms.TextBox
$outputBox.Location = New-Object System.Drawing.Size(10, 150)
$outputBox.Size = New-Object System.Drawing.Size(565, 200)
$outputBox.MultiLine = $True
$outputBox.ScrollBars = "Vertical"
$Form.Controls.Add($outputBox)

############################################## end text fields

############################################## Start buttons

$Button = New-Object System.Windows.Forms.Button
$Button.Location = New-Object System.Drawing.Size(400, 30)
$Button.Size = New-Object System.Drawing.Size(110, 80)
$Button.Text = "Ping"
$Button.Add_Click( { pingInfo })
$Form.Controls.Add($Button)

############################################## end buttons
## Adds
$Form.StartPosition = "CenterScreen" #loads the window in the center of the screen
$Form.FormBorderStyle = [System.Windows.Forms.FormBorderStyle]::FixedToolWindow #modifies the window border
$Form.Text = "Ping GUI tool" #window description
$outputBox.Font = New-Object System.Drawing.Font("Verdana", 8, [System.Drawing.FontStyle]::Italic)
$Button.Cursor = [System.Windows.Forms.Cursors]::Hand
$Button.BackColor = [System.Drawing.Color]::LightGreen
$Button.Font = New-Object System.Drawing.Font("Verdana", 14, [System.Drawing.FontStyle]::Bold)

$Form.Add_Shown( { $Form.Activate() })
[void] $Form.ShowDialog()
